/*
 * Experiment 4: Find the key
 * Find all the details about this experiment in the book << The Logic of things >>
 * Created 23 March 2017
 * By Zeroplus Technology Co. Ltd
 */
 
const int sensorPin = 0, LEDPin = 13;
const int pin3 = 3, pin4 = 4, pin5 = 5, pin6 = 6, pin7 = 7;

int lightIntensity, sensorHigh = 0, sensorLow = 1023, inputValue = 0, unknownValue = 0;
int bit0 = 0, bit1 = 0, bit2 = 0, bit3 = 0, bit4 = 0;

void setup() {
  pinMode(LEDPin, OUTPUT);
  
  /* The pins 3 to 7 are configured as outputs. */
  pinMode(pin3, OUTPUT);
  pinMode(pin4, OUTPUT);
  pinMode(pin5, OUTPUT);
  pinMode(pin6, OUTPUT);
  pinMode(pin7, OUTPUT);

  /* Generate a random number between 0 and 31 */
  randomSeed(analogRead(0));
  unknownValue = random(0, 31);
  
  calibrate();
}

void loop() {
  lightIntensity = analogRead(sensorPin); // Reads the value from the photosensor.
  writeToPins(lightIntensity);         // Value written on the pins 3 to 7. Each output represents one bit.
  inputValue = readFromPins();    // Read the value from the pins 3 to 7.

  /* Compare the value read from the inputs to a randomly generated number and turn the LED on when they are equal. */
  if (inputValue == unknownValue) {
    digitalWrite(LEDPin, HIGH);
  }
  else {
    digitalWrite(LEDPin, LOW);
  }
  delay(30);
}

/* The value read from the sensor is decomposed into 5 bits. The bits are written on the pins 3 to 7. */
void writeToPins(int sensor_value) {
  digitalWrite(pin3, bitRead(sensor_value, 0));
  digitalWrite(pin4, bitRead(sensor_value, 1));
  digitalWrite(pin5, bitRead(sensor_value, 2));
  digitalWrite(pin6, bitRead(sensor_value, 3));
  digitalWrite(pin7, bitRead(sensor_value, 4));
  }

/* Read the pins 3 to 7 and combine their value into one number */
int readFromPins() {
  int value = 0;
  bit0 = digitalRead(pin3);
  bit1 = digitalRead(pin4);
  bit2 = digitalRead(pin5);
  bit3 = digitalRead(pin6);
  bit4 = digitalRead(pin7);
  return value = ((bit4 << 4) | (bit3 << 3) | (bit2 << 2) | (bit1 << 1) | bit0);
}
/* Detect the min and max values measured in the room. */
int adjustSensitivity(int light) {
  if (light < sensorLow) {
    sensorLow = light;
  }
  if (light > sensorHigh) {
    sensorHigh = light;
  }
  light = map(light, sensorLow, sensorHigh, 0, 31);
  light = constrain(light, 0, 31);
  return light;
}

void calibrate(){
  for(int i=0;i<100;i++){
     lightIntensity = analogRead(sensorPin);
     lightIntensity = adjustSensitivity(lightIntensity);
     delay(30);
     }
  }
