/*
 * Logic Acquistion and Software Tutorial
 * Find all the details about this experiment in the book << The Logic of things >>]
 * Created 10 March 2017.  Modified 7 August 2017
 * By Zeroplus Technology Co. Ltd
 */

// Define Function Options  
#define GENERATE_CLOCK '1'
#define COUNTER '2'
#define COUNTER_2 '3'
#define STATE_MODE '4'

// Define Pin numbers
#define PIN2 2
#define PIN8 8
#define PIN9 9
#define PIN10 10
#define PIN11 11
#define PIN12 12
#define PIN13 13

char selection = '1';
char inbyte;
int incrementer = 0;
byte busCounter = B00000000;

void setup() {
  // All pins used in this example are outputs
  pinMode(PIN2, OUTPUT);
  pinMode(PIN8, OUTPUT);
  pinMode(PIN9, OUTPUT);
  pinMode(PIN10, OUTPUT);
  pinMode(PIN11, OUTPUT);
  pinMode(PIN12, OUTPUT);
  pinMode(PIN13, OUTPUT);

  DDRB = B11111111;
  Serial.begin(9600);

  // Display Menu
  Serial.println("Function Menu\n");
  Serial.println("1 - Generate Clock on Pin 8");
  Serial.println("2 - 5 Bit Counter");
  Serial.println("3 - 5 Bit Counter using DigitalWrite");
  Serial.println("4 - State Mode\n");
  Serial.println("Enter a Number");
}

void loop() {
  /* Generate a simple clock */
  switch (selection) {
    case GENERATE_CLOCK:
      digitalWrite(PIN8, (digitalRead(PIN8) == HIGH ? LOW : HIGH));
      delay(5);
      break;

  // 5 bit counter    
  case COUNTER:
    for(busCounter = 0; busCounter<32; busCounter++) {
      PORTB = busCounter;
      delay(5);
    }
    break;

  // 6 bit counter using digitalWrite  
  case COUNTER_2:
    for(busCounter = 0; busCounter<64; busCounter++) {
      digitalWrite(PIN8, bitRead(busCounter, 0));
      digitalWrite(PIN9, bitRead(busCounter, 1));
      digitalWrite(PIN10, bitRead(busCounter, 2));
      digitalWrite(PIN11, bitRead(busCounter, 3));
      digitalWrite(PIN12, bitRead(busCounter, 4));
      digitalWrite(PIN13, bitRead(busCounter, 5));
      delay(5);
    }
    break;
    /* State mode. 
      * This counter is similar counter to the previous one, but we add a clock so that we can perform a state acquisition.
    */
  case STATE_MODE:
    for(busCounter = 0; busCounter<16; busCounter++) {
      digitalWrite(PIN2, (digitalRead(PIN2) == HIGH ? LOW : HIGH));
      delay(1);
      digitalWrite(PIN8, bitRead(busCounter, 1));
      digitalWrite(PIN9, bitRead(busCounter, 2));
      digitalWrite(PIN10, bitRead(busCounter, 3));
    }
    break;
  }
  
  // Read all the Serial buffer, discard all bytes except for last read.  If an invalid number is read, ignore it
  // and keep last selection
  while (Serial.available() > 0) {
    inbyte = Serial.read();
    if (inbyte >= '1' && inbyte <= '4')
      selection = inbyte;
  }
}

