/*
 * Experiment 2: Photoresistor
 * Find all the details about this experiment in the book << The Logic of things >>
 * Created 10 March 2017
 * By Zeroplus Technology Co. Ltd
 */
const int photoresistorPin = 0;
int bit0 = 3, bit1 = 4, bit2 = 5, bit3 = 6, bit4 = 7, bit5 = 8, bit6 = 9, lightValue = 0, sensorHigh = 0, sensorLow = 1023;

void setup() {
  pinMode(photoresistorPin, INPUT);
  pinMode(bit0, OUTPUT);
  pinMode(bit1, OUTPUT);
  pinMode(bit2, OUTPUT);
  pinMode(bit3, OUTPUT);
  pinMode(bit4, OUTPUT);
  pinMode(bit5, OUTPUT);
  pinMode(bit6, OUTPUT);

  calibrate();
}

void loop() {
  /* Read the value from the pin connected to the photoresistor.
   * Decompose into 7 bits the value read from the photoresistor and send each bit to a pin.
  */
  lightValue = analogRead(photoresistorPin);  
  digitalWrite(bit0, bitRead(lightValue,0));
  digitalWrite(bit1, bitRead(lightValue,1)); 
  digitalWrite(bit2, bitRead(lightValue,2));
  digitalWrite(bit3, bitRead(lightValue,3));
  digitalWrite(bit4, bitRead(lightValue,4));
  digitalWrite(bit5, bitRead(lightValue,5));
  digitalWrite(bit6, bitRead(lightValue,6));
  delay(20);
  }

/* Detect the min and max values measured in the room. */
int adjustSensitivity(int light) {
  if (light < sensorLow) {
    sensorLow = light;
  }
  if (light > sensorHigh) {
    sensorHigh = light;
  }
  light = map(light, sensorLow, sensorHigh, 0, 100);
  light = constrain(light, 0, 100);
  return light;
}

void calibrate(){
  for(int i=0;i<100;i++){
     lightValue = analogRead(photoresistorPin);  
     lightValue = adjustSensitivity(lightValue);
     delay(30);
     }
  }
