/*
 * Experiment 3: Sensors
 * Find all the details about this experiment in the book << The Logic of things >>
 * Created 23 March 2017
 * By Zeroplus Technology Co. Ltd
 */

const int soundLEDPin = 4, lightLEDPin = 5, soundSensorOutput = 2, lightSensorOutput = 0;
const long timeInterval = 200;
int lightSensor = 0, soundSensor = 0;
long soundStartTime = 0, soundCurrentTime = 0;
bool soundLED = LOW, lightLED = LOW;

void setup() {
  pinMode(lightSensorOutput, INPUT);
  pinMode(soundSensorOutput, INPUT);
  pinMode(soundLEDPin, OUTPUT);
  pinMode(lightLEDPin, OUTPUT);

  Serial.begin(9600);
}

void loop() {
  /* Read the sensors.
   *  Call millis(): 
   *    >> We want to know the time when the sound sensor detected a sound above its threshold.
   *    >> We will use this information to maintain its LED turned on for 200ms before turning it back off.
   *  Check whether the sensors measured a value above their threshold.
  */
  soundSensor = analogRead(soundSensorOutput);
  lightSensor = analogRead(lightSensorOutput);
  Serial.print(soundSensor);
  Serial.print("\n");
  unsigned long currentMillis = millis();

  if(soundSensor>60) {
    soundLED = HIGH;
    soundStartTime = currentMillis;
    }
  if(lightSensor>500) {
    lightLED = HIGH;
  }
  else if(lightSensor<500) {
    lightLED = LOW;
  }

  /*
   * The function millis() is preferable to delay() in some circunstances because it doesn't stop the programm.
   * Below we monitor the period of time the LED was on. We turn it off when this period of time is greater than timeInterval .
   */
  if(soundLED == HIGH) {
    soundCurrentTime = currentMillis;
    if((soundCurrentTime - soundStartTime) >= timeInterval) {
      soundLED = LOW;
      }
  }
  /* Update the status of the LEDs. */
  digitalWrite(soundLEDPin, soundLED);
  digitalWrite(lightLEDPin, lightLED);
}
